log4cplus::Log4jUdpAppender Class Reference

Sends log events as Log4j XML to a remote a log server. More...

`#include <log4judpappender.h>`

Inheritance diagram for log4cplus::Log4jUdpAppender:
[legend]
Collaboration diagram for log4cplus::Log4jUdpAppender:
[legend]

## Public Member Functions

| Log4jUdpAppender (const log4cplus::tstring &host, int port, bool ipv6=false)
| Log4jUdpAppender (const log4cplus::helpers::Properties &properties)
| ~Log4jUdpAppender ()
virtual void | close ()
| Release any resources allocated within the appender such as file handles, network connections, etc.
Public Member Functions inherited from log4cplus::Appender
| Appender ()
| Appender (const log4cplus::helpers::Properties &properties)
virtual | ~Appender ()
void | destructorImpl ()
| This function is for derived appenders to call from their destructors.
bool | isClosed () const
| Check if this appender is in closed state.
void | syncDoAppend (const log4cplus::spi::InternalLoggingEvent &event)
| This method performs threshold checks and invokes filters before delegating actual logging to the subclasses specific `append` method.
void | asyncDoAppend (const log4cplus::spi::InternalLoggingEvent &event)
| This method performs book keeping related to asynchronous logging and executes syncDoAppend() to do the actual logging.
void | doAppend (const log4cplus::spi::InternalLoggingEvent &event)
| This function checks async flag.
virtual log4cplus::tstring | getName ()
| Get the name of this appender.
virtual void | setName (const log4cplus::tstring &name)
| Set the name of this appender.
virtual void | setErrorHandler (std::unique_ptr< ErrorHandler > eh)
| Set the `ErrorHandler` for this Appender.
virtual ErrorHandler * | getErrorHandler ()
| Return the currently set `ErrorHandler` for this Appender.
virtual void | setLayout (std::unique_ptr< Layout > layout)
| Set the layout for this appender.
virtual Layout * | getLayout ()
| Returns the layout of this appender.
void | setFilter (log4cplus::spi::FilterPtr f)
| Set the filter chain on this Appender.
log4cplus::spi::FilterPtr | getFilter () const
| Get the filter chain on this Appender.
void | addFilter (log4cplus::spi::FilterPtr f)
| Add filter at the end of the filters chain.
void | addFilter (std::function< spi::FilterResult(const log4cplus::spi::InternalLoggingEvent &)>)
| Add filter at the end of the filters chain.
LogLevel | getThreshold () const
| Returns this appenders threshold LogLevel.
void | setThreshold (LogLevel th)
| Set the threshold LogLevel.
bool | isAsSevereAsThreshold (LogLevel ll) const
| Check whether the message LogLevel is below the appender's threshold.
void | waitToFinishAsyncLogging ()
| This method waits for all events that are being asynchronously logged to finish.
Public Member Functions inherited from log4cplus::helpers::SharedObject
void | addReference () const LOG4CPLUS_NOEXCEPT
void | removeReference () const

## Protected Member Functions

void | openSocket ()
virtual void | append (const spi::InternalLoggingEvent &event)
| Subclasses of `Appender` should implement this method to perform actual logging.
Protected Member Functions inherited from log4cplus::Appender
tstring & | formatEvent (const log4cplus::spi::InternalLoggingEvent &event) const
Protected Member Functions inherited from log4cplus::helpers::SharedObject
| SharedObject ()
| SharedObject (const SharedObject &)
| SharedObject (SharedObject &&)
virtual | ~SharedObject ()
SharedObject & | operator= (const SharedObject &) LOG4CPLUS_NOEXCEPT
SharedObject & | operator= (SharedObject &&) LOG4CPLUS_NOEXCEPT

## Protected Attributes

log4cplus::helpers::Socket | socket
log4cplus::tstring | host
int | port
bool | ipv6 = false
Protected Attributes inherited from log4cplus::Appender
std::unique_ptr< Layout > | layout
| The layout variable does not need to be set if the appender implementation has its own layout.
log4cplus::tstring | name
| Appenders are named.
LogLevel | threshold
| There is no LogLevel threshold filtering by default.
log4cplus::spi::FilterPtr | filter
| The first filter in the filter chain.
std::unique_ptr< ErrorHandler > | errorHandler
| It is assumed and enforced that errorHandler is never null.
std::unique_ptr< helpers::LockFile > | lockFile
| Optional system wide synchronization lock.
bool | useLockFile
bool | async
| Asynchronous append.
std::atomic< std::size_t > | in_flight
std::mutex | in_flight_mutex
std::condition_variable | in_flight_condition
bool | closed
| Is this appender closed?

## Additional Inherited Members

Public Attributes inherited from log4cplus::helpers::SharedObject
thread::Mutex | access_mutex

## Detailed Description

Sends log events as Log4j XML to a remote a log server.

The Log4jUdpAppender has the following properties:

- Remote logging is non-intrusive as far as the log event is concerned. In other words, the event will be logged with the same time stamp, NDC, location info as if it were logged locally by the client.

- Remote logging uses the UDP protocol.

### Properties

host

  Remote host name to connect and send events to.

port

  Port on remote host to send events to. Default is 5000.

IPv6

  Boolean value specifying whether to use IPv6 (true) or IPv4 (false). Default value is false.

Definition at line 61 of file log4judpappender.h.

## Constructor & Destructor Documentation

## Log4jUdpAppender() [1/2]

log4cplus::Log4jUdpAppender::Log4jUdpAppender | ( | const log4cplus::tstring & | host,
|  | int | port,
|  | bool | ipv6 = false )

References host, ipv6, and port.

## Log4jUdpAppender() [2/2]

log4cplus::Log4jUdpAppender::Log4jUdpAppender | ( | const log4cplus::helpers::Properties & | properties | ) |

## ~Log4jUdpAppender()

log4cplus::Log4jUdpAppender::~Log4jUdpAppender | ( |  | ) |

## Member Function Documentation

## append()

virtual void log4cplus::Log4jUdpAppender::append | ( | const spi::InternalLoggingEvent & | event | ) |

protected virtual

Subclasses of `Appender` should implement this method to perform actual logging.

See also
  doAppend method.

Implements log4cplus::Appender.

## close()

virtual void log4cplus::Log4jUdpAppender::close | ( |  | ) |

virtual

Release any resources allocated within the appender such as file handles, network connections, etc.

It is a programming error to append to a closed appender.

Implements log4cplus::Appender.

## openSocket()

void log4cplus::Log4jUdpAppender::openSocket | ( |  | ) |

protected

## Member Data Documentation

## host

log4cplus::tstring log4cplus::Log4jUdpAppender::host

protected

Definition at line 80 of file log4judpappender.h.

Referenced by Log4jUdpAppender().

## ipv6

bool log4cplus::Log4jUdpAppender::ipv6 = false

protected

Definition at line 82 of file log4judpappender.h.

Referenced by Log4jUdpAppender().

## port

int log4cplus::Log4jUdpAppender::port

protected

Definition at line 81 of file log4judpappender.h.

Referenced by Log4jUdpAppender().

## socket

log4cplus::helpers::Socket log4cplus::Log4jUdpAppender::socket

protected

Definition at line 79 of file log4judpappender.h.

The documentation for this class was generated from the following file:

- log4judpappender.h